 package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxBasic;
import org.flixel.FlxTilemap;
import org.flixel.FlxObject;
import org.flixel.FlxEmitter;
import org.flixel.FlxParticle;
import org.flixel.FlxSave;
import org.flixel.FlxSound;
import nme.Assets;
import nme.media.Sound;
import nme.media.SoundTransform;
import haxe.Timer;



import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Elastic;



class BaseLevel extends FlxState
{
	//This is for our messages
	private var topText:FlxText;
	
	//overlay
	private var overlay:FlxSprite;
	private var overlayGroup:FlxGroup;
	private var levelInfo:FlxText;

	//basementSprites
	private var robotGroup:FlxGroup;
	private var backGround:FlxSprite;

	//jason sprite
	public var ourPlayer:Player;
	public var roboHead:RobotHead;


	//map
	private var map:FlxTilemap;

	//headgroup
	private var headGroup:FlxGroup;
	private var headCounter:Float;

	//taco
	private var taco:FlxSprite;
	private var hasTaco:Bool;

	//doors
	private var doorGroup:FlxGroup;

	//buttons
	private var buttonGroup:FlxGroup;

	//enemies
	private var enemyGroup:FlxGroup;

	public var hsquare:FlxSprite;

	//enviro group
	public var enviroGroup:FlxGroup;

	//bullet group
	public var lazerGroup:FlxGroup;

	//powerUGroup
	public var powerUGroup:FlxGroup;

	//platformGroup
	public var platformGroup:FlxGroup;

	public var spitGroup:FlxGroup;

	public var trampGroup:FlxGroup;

	public var eBulletGroup:FlxGroup;

	public var powerUpGroup:FlxGroup;

	public var forceGroup:FlxGroup;

	//reset
	private var reset:Int;

	//robotEyes
	public var eyes:Eyes;

	public var tacoText:FlxText;

	public var stars:FlxSprite;
	public var bigStar:FlxSprite;
	public var scoreStar:FlxSprite;

	public var ourForceField:FlxSprite;

	public var lazerMadnessTimer:Float;
	public var lazerMadnnessOffset:Int;
	public var gameOver:Bool;
	public var lifeIcon:FlxSprite;
	public var lifeText:FlxText;
	private var randW1:Int;
	private var randW2:Int;

	//SOUND VARS
	private var copterSound:FlxSound;
	private var lazerSound:FlxSound;
	private var explosionSound:FlxSound;
	public var buttonClick:FlxSound;
	public var enemyExplosion:FlxSound;
	public var powerUpSound:FlxSound;
	public var wallExplosion:FlxSound;
	public var zapSound:FlxSound;
	public var dingSound:FlxSound;
	public var gameOverSound:FlxSound;
	public var powerUpTimer:Timer;
	public var powerUpTimer2:Timer;
	public var homeButton:FlxSprite;



	
	


	public function new(r:Int=1)
	{
		reset = r;
		super();
	}
	
	override public function create():Void
	{

		//Home Button
		homeButton = new FlxSprite(10,10);
		homeButton.makeGraphic(20,20,0xffffffff);
		homeButton.alpha=.8;
		add(homeButton);
		//check to make sure we can't die after we hit taco
		hasTaco = false;

		//SOUND STUFF
		copterSound = FlxG.loadSound(Assets.getSound ("assets/sounds/Copter2.wav"),.4,true);
		lazerSound = FlxG.loadSound(Assets.getSound ("assets/sounds/LAZER2.mp3"),.45);
		explosionSound = FlxG.loadSound(Assets.getSound ("assets/sounds/Explosion1.mp3"),.86);
		buttonClick = FlxG.loadSound(Assets.getSound ("assets/sounds/Click.mp3"),.25);
		enemyExplosion = FlxG.loadSound(Assets.getSound ("assets/sounds/ExplosionEnemy.mp3"),.5);
		wallExplosion = FlxG.loadSound(Assets.getSound ("assets/sounds/Explosion2.mp3"),.40);
		powerUpSound = FlxG.loadSound(Assets.getSound ("assets/sounds/PowerUp.mp3"),.425);
		zapSound = FlxG.loadSound(Assets.getSound ("assets/sounds/Zap.mp3"),.35);
		dingSound = FlxG.loadSound(Assets.getSound ("assets/sounds/DING.mp3"),.45);
		gameOverSound = FlxG.loadSound(Assets.getSound ("assets/sounds/GameOver.mp3"),.9);	




		//Kick the framerate back up
		robotGroup = new FlxGroup();
		headGroup = new FlxGroup();
		doorGroup = new FlxGroup();
		buttonGroup = new FlxGroup();
		enemyGroup = new FlxGroup();
		enviroGroup = new FlxGroup();
		lazerGroup = new FlxGroup();
		powerUGroup = new FlxGroup();
		platformGroup = new FlxGroup();
		spitGroup = new FlxGroup();
		trampGroup = new FlxGroup();
		eBulletGroup = new FlxGroup();
		powerUpGroup = new FlxGroup();
		forceGroup = new FlxGroup();
		gameOver = false;
		//map = new FlxTilemap();


		

		//add the map
		//setupMap();
		//add(map);
		
		//item stuff
		
		add(buttonGroup);
		add(doorGroup);
		add(platformGroup);
		add(enviroGroup);
		
		add(lazerGroup);
		add(powerUGroup);
		add(spitGroup);
		add(trampGroup);

	
		//taco
		taco = new FlxSprite(768,560);
		taco.loadGraphic(FlxAssets.tacoImg,true,false,24,22);
		//taco.addAnimation("fader",[0,1,2,3,4,5,4,3,2,1],8);
		//taco.play("fader");
		add(taco);

        add(enemyGroup);
		
		//our mainPlayer
		ourPlayer = new Player(40,320);
		add(ourPlayer);
		robotGroup.add(ourPlayer);


		//head stuff
		headCounter = 0;
		add(headGroup);

		add(forceGroup);
		//stuff to do if we are not on the
		if (FlxAssets.level>0) {
			stars = new FlxSprite(taco.x,taco.y-12);
			stars.loadGraphic(FlxAssets.starsImg,true,false,25,6);
			if (FlxAssets.tacoNum==2) {
				stars.frame = 1;
			}
			else if (FlxAssets.tacoNum==1){
				stars.frame=2;
			}
			else{
				stars.frame=0;
			}

			add(stars);

			//tacoText = new FlxText(774,18,22);
			tacoText = new FlxText(757,22,42);
			tacoText.setFont("assets/bithigh");
			tacoText.setFormat(16,0xffffffff,"center");
			//tacoText.text = Std.string(FlxAssets.totalTacos);
			tacoText.text = Std.string(FlxAssets.totalTacos)+"/"+Std.string((FlxAssets.level-1)*3);
			//tacoText.text = "4/24";
			add(tacoText);

			//big star
			//bigStar = new FlxSprite(780,10);
			bigStar = new FlxSprite(773,12);
			//bigStar.alpha=.85;
			bigStar.loadGraphic(FlxAssets.starBig);
			add(bigStar);

			//overlay
			overlayGroup = new FlxGroup();

			overlay = new FlxSprite(0,0);
			overlay.makeGraphic(FlxG.width,FlxG.height,0xff000000);
			add(overlay);

			levelInfo = new FlxText(0,FlxG.height*.45,FlxG.width);
			levelInfo.setFont("assets/bithigh");
			levelInfo.setFormat(32,0xffffffff,"center",0xff363636);
			levelInfo.text="LEVEL " + FlxAssets.level;
			add(levelInfo);



			Actuate.update (overlay.setAlpha, 3, [1],[0]);
			
			if(reset==1){
				Actuate.update (levelInfo.setAlpha, 1.5, [1],[0])
				.delay(1);
			}
			else{
				levelInfo.setAlpha(0);
			}

			if (FlxAssets.gameMode==2) {
				stars.visible=false;
				bigStar.visible=false;
				tacoText.visible=false;
			}
			else{
				//stars fade
				stars.scale.x=0;
				stars.scale.y=0;
				Actuate.tween(stars.scale,1,{x:1,y:1}).delay(.25);
				Actuate.tween(stars.scale,1.5,{x:0,y:0},false).delay(3.125);
				Actuate.update (stars.setAlpha, 1.5, [1],[0])
				.delay(3);	
			}

		}//end of check to see if we are on the menu state

		//FlxG.mouse.hide();

		//check to see if we have a force field if so add it
		if (FlxAssets.hasForce) {
			makeForceField();
		}

		eyes = new Eyes(ourPlayer.x,ourPlayer.y);
		eyes.visible=false;

		if (FlxAssets.gameMode==2) {
			lifeIcon = new FlxSprite(760,15,FlxAssets.livesImg);
			add(lifeIcon);

			lifeText = new FlxText(782,13.5,46);
			lifeText.setFont("assets/bithigh");
			lifeText.setFormat(16,0xffffffff);
			lifeText.text =  Std.string(FlxAssets.hotLives);
			add(lifeText);
		}











	}


	//levelComplete
	public function levelComplete():Void{
		//stars.alpha = 1;
		//stars.scale.y=1.5;
		//stars.scale.x=1.5;
		//stars.x = ourPlayer.x-6;
		//stars.y = ourPlayer.y - 6;
		//Actuate.tween(stars.scale,1,{x:0,y:0},false).delay(.125);
		//Actuate.update (stars.setAlpha, 1, [1],[0]);





		Actuate.update (overlay.setAlpha, 2, [0],[1])
		.ease (Elastic.easeOut)
		.delay(.75)
		.onComplete(nextLevel);

		//levelInfo.text = "!!! TACO !!!";
		Actuate.update (levelInfo.setAlpha, 1.25, [0],[1])
		.ease (Elastic.easeOut)
		.onComplete(fadeWin);
		
		levelInfo.size=64;



		Actuate.update (levelInfo.setSize, 2, [24],[48])
		.ease (Elastic.easeOut);

		FlxAssets.totalTacos+= FlxAssets.tacoNum;
		

		if (FlxAssets.gameMode==1) {
			//save game nonsense
			if(FlxAssets.saveGame.bind("RobotWants")){
					if(FlxAssets.saveGame.data.mildScore==null){
						FlxAssets.saveGame.data.mildScore=FlxAssets.totalTacos;
					}
					else if (FlxAssets.totalTacos>FlxAssets.saveGame.data.mildScore) {
						FlxAssets.saveGame.data.mildScore=FlxAssets.totalTacos;		
					}

					if (FlxAssets.level>FlxAssets.saveGame.data.ourLevel) {
						FlxAssets.saveGame.data.ourLevel++;	
						//FlxAssets.saveGame.close();
					}
					FlxAssets.saveGame.close();

			}

			//scoreStar = new FlxSprite(387.5,levelInfo.y+72);
			scoreStar = new FlxSprite(390,levelInfo.y+72);
			scoreStar.loadGraphic(FlxAssets.starsImg,true,false,25,6);
			scoreStar.scale.x=0;
			scoreStar.scale.y=0;

			if (FlxAssets.tacoNum==2) {
				scoreStar.frame = 1;
			}
			else if (FlxAssets.tacoNum==1){
				scoreStar.frame=2;
			}
			else{
				scoreStar.frame=0;
			}
			Actuate.tween(scoreStar.scale,.5,{x:2,y:2});
			Actuate.update (scoreStar.setAlpha, 1.75, [1],[0]).delay(1.75);

			add(scoreStar);
		}
		FlxAssets.tacoNum=3;
		FlxAssets.level++;



	}

	public function fadeWin():Void{
		Actuate.update (levelInfo.setAlpha, 1.75, [1],[0]).delay(.5);
		//.ease (Elastic.easeOut);
		
	}

	public function nextLevel():Void{
		FlxG.switchState(new Level1());
	}
	
	override public function update():Void
	{
		super.update();

		if (ourPlayer.x<1) {
			ourPlayer.velocity.x=0;
			ourPlayer.x=2;
		}
		else if (ourPlayer.x+8>FlxG.width) {
			ourPlayer.velocity.x=0;
			ourPlayer.x = FlxG.width-9;
		}



		


		//collisions
		FlxG.collide(ourPlayer,enemyGroup,playerEnemyHit);
		FlxG.collide(robotGroup,enemyGroup,playerEnemyHit);

		FlxG.collide(robotGroup,powerUpGroup,hitPowerUP);
		FlxG.collide(ourPlayer,powerUpGroup,hitPowerUP);


		if(ourPlayer.control){

			FlxG.camera.follow(ourPlayer);
		}
		else{
			FlxG.camera.follow(roboHead);
		}
		
		FlxG.camera.setBounds(0,0,800,600);
		FlxG.collide(map,headGroup);
		//FlxG.collide(map,ourPlayer);
		if(FlxG.collide(map,ourPlayer)&&ourPlayer.tramp){
			mapHitter();
		}


		//connect head back to body
		if(FlxG.collide(ourPlayer,headGroup)&&headCounter>=1){
				headGroup.clear();
				roboHead.kill();
				headCounter=0;
				copterSound.stop();
				ourPlayer.getHead();
			
		}

		//check to see if the complete robot hits the taco
		if(FlxG.overlap(ourPlayer,taco)&&!ourPlayer.headless&&taco.alpha!=0){
			taco.kill();
			hasTaco = true;
			makeTacoSound(FlxAssets.tacoNum);
		}

		//if ourPlayer is headless don't allow reattachment for 1 second
		if(ourPlayer.headless){
			headCounter+=FlxG.elapsed;
		}

		//swap to headless
		if(FlxG.keys.justPressed("X")){
			if(!ourPlayer.headless){
				ourPlayer.loseHead();
				copterSound.play();
				//test robot head
				roboHead = new RobotHead(ourPlayer.x,ourPlayer.y-12);
				roboHead.facing = ourPlayer.facing;
				robotGroup.add(roboHead);
				headGroup.add(roboHead);

			}
			//swap control
			else{
				FlxG.log(roboHead.control);
				if(roboHead.control){			
					roboHead.control=false;
					ourPlayer.control=true;
					ourPlayer.flicker(.1);
				}
				else{
					roboHead.control=true;
					ourPlayer.control=false;
					roboHead.flicker(.1);
				}
			}//end of else

		}//end of swap control

		//lazer Shooting

		if (FlxG.keys.pressed("SPACE")&&!FlxAssets.hasSuperShot&&FlxAssets.level>=4) {
			ourPlayer.stillTime = 0;
			if (ourPlayer.alive==false) {
				eyes.visible=false;
			}
			if (ourPlayer.headless&&roboHead.alive==false) {
				eyes.visible=false;	
			}
			//check to see if the player is stopped
			if (ourPlayer.stillTime>=3) {
				ourPlayer.frame=2;
			}//end of still check

			if (!ourPlayer.lazerCharging) {
				ourPlayer.lazerCharging = true;
				eyes = new Eyes(ourPlayer.x,ourPlayer.y);
		        add(eyes);
				//if our player is on control
			
			}//end of check charging

			else{
		

			}

		}

		if (FlxG.keys.justReleased("SPACE")&&ourPlayer.alive&&!FlxAssets.hasSuperShot) {
			ourPlayer.lazerCharging = false;
			
			if (eyes.charged) {
				shootLazer();
				lazerSound.play();
			}
			eyes.kill();
		}



		//make sure robot is in bounds otherwise reset
		if(ourPlayer.y>FlxG.height||ourPlayer.x>FlxG.width+24||ourPlayer.x<-24){
			FlxAssets.hasTriple=false;
			resetLevel();

			if (FlxAssets.hasForce) {
				destroyForceField();
			}
		}

		if (ourPlayer.headless&&roboHead.y>FlxG.height+16&&!hasTaco) {
			FlxAssets.hasTriple=false;
			resetLevel();
			if (FlxAssets.hasForce) {
				destroyForceField();
			}
		}

		//eyes.x = ourPlayer.x;
		//eyes.y = ourPlayer.y;

		if (FlxAssets.hasSuperShot) {
			lazerMadness();
		}



	}//end of update

	public function makeTacoSound(t:Int){
		 dingSound.play();
		//var :Array = new Array("TACO","FIESTA","RADICAL","GREAT","GNARLY","SUPER");
		//var tacoTemp:FlxSound = FlxG.loadSound(Assets.getSound("assets/sounds/TACO.mp3"),1,false,true);
		if (t==1) {
			//soundCallBack(tacoTemp);
			levelInfo.text = "!!! TACO !!!";
			FlxAssets.tacoSoundArray[0].play(0,0,new SoundTransform(.6));
		}
		else if(t==2){
			 randW1 = FlxG.randomRange2(FlxAssets.wordArray.length,0);
			 randW2 = FlxG.randomRange2(FlxAssets.wordArray.length,0);
			if (randW2>FlxAssets.FlxAssets.wordArray.length*.5) {
				levelInfo.text = "!!! "+FlxAssets.wordArray[randW1]+" TACO !!!";
			    //var tSound:FlxSound = FlxG.loadSound(Assets.getSound("assets/sounds/TACO.mp3"),1,false,true);
				FlxAssets.tacoSoundArray[randW1].play(0,0,new SoundTransform(.6));	
				haxe.Timer.delay(callback(soundCallBack,0), 600); 
			}
			else{
				levelInfo.text = "!!! TACO "+FlxAssets.wordArray[randW1]+" !!!";	
				FlxAssets.tacoSoundArray[0].play(0,0,new SoundTransform(.6));
				haxe.Timer.delay(callback(soundCallBack,randW1), 600); 		
			}

		}
		else{
			randW1 = FlxG.randomRange2(FlxAssets.wordArray.length,0);
			randW2 = FlxG.randomRange2(FlxAssets.wordArray.length,0);
			if (randW2>FlxAssets.wordArray.length*.5) {
				levelInfo.text = "!!! "+FlxAssets.wordArray[randW1]+" "+FlxAssets.wordArray[randW2]+" TACO !!!";
				FlxAssets.tacoSoundArray[randW1].play(0,0,new SoundTransform(.6));

				haxe.Timer.delay(callback(soundCallBack,randW2), 600); 	
				haxe.Timer.delay(callback(soundCallBack,0), 1200); 	
			}
			else{
				levelInfo.text = "!!! TACO "+FlxAssets.wordArray[randW1]+" "+FlxAssets.wordArray[randW2]+" !!!";
				FlxAssets.tacoSoundArray[0].play(0,0,new SoundTransform(.6));
				haxe.Timer.delay(callback(soundCallBack,randW1), 600); 	
				haxe.Timer.delay(callback(soundCallBack,randW2), 1200); 	
			}
		}
		levelComplete();
	}

	public function soundCallBack(which:Int):Void{
		//var soundTrans:SoundTransform = new SoundTransform(.8);
		FlxAssets.tacoSoundArray[which].play(0,0,new SoundTransform(.6));
	}

	public function updateParts(){
		if (FlxAssets.hasForce) {
			if (ourPlayer.headless) {
				ourForceField.x=ourPlayer.x-10;
				ourForceField.y=ourPlayer.y-11;
			}
			else{  
				ourForceField.x=ourPlayer.x-10;
				ourForceField.y=ourPlayer.y+.5;
			}
		}//

		if (ourPlayer.control&&!ourPlayer.headless) {
					eyes.facing=ourPlayer.facing;
					eyes.x=ourPlayer.x;
					eyes.y=ourPlayer.y;
			}
			else{
					eyes.facing=roboHead.facing;
					eyes.x=roboHead.x+2;
					eyes.y=roboHead.y-3;
			}
	}

	public function hotGameOver():Void{
			if (!gameOver) {
				// check to see if we have a new high level if so write it in
				if(FlxAssets.saveGame.bind("RobotWants")){
					if(FlxAssets.saveGame.data.hotLevel==null){
						FlxAssets.saveGame.data.hotLevel=FlxAssets.level;
						FlxAssets.saveGame.close();
					}
					else if (FlxAssets.level>FlxAssets.saveGame.data.hotLevel) {
						FlxAssets.saveGame.data.hotLevel=FlxAssets.level;	
						FlxAssets.saveGame.close();
					}
				}
				lifeText.kill();
				lifeIcon.kill();
				FlxAssets.gameMode=0;
				gameOver=true;
				Actuate.update (overlay.setAlpha, 2, [0],[1])
				.ease (Elastic.easeOut)
				.delay(.75);

				levelInfo.text = "GAME OVER";
				Actuate.update (levelInfo.setAlpha, 1.25, [0],[1])
				.ease (Elastic.easeOut);
				gameOverSound.play();
				
				levelInfo.size=64;
				Actuate.update (levelInfo.setSize, 2, [24],[48])
				.ease (Elastic.easeOut)
				.onComplete(resetTheGame);
			}
	}

	public function resetTheGame(){
		FlxG.resetGame();
	}

 	private function enviroHit(p:FlxSprite,e:FlxSprite):Void{
 		if (FlxAssets.hasForce) {
 			if (ourPlayer.velocity.y>0) {
 				ourPlayer.velocity.y=-450;
 			}
 			else{
 				ourPlayer.velocity.y=450;
 			}

 			if (ourPlayer.velocity.x>0) {
 				ourPlayer.velocity.x=-450;		
 			}
 			else{
 				ourPlayer.velocity.x=450;
 			}
 			haxe.Timer.delay(callback(destroyForceField), 333); 
 			
 		}
 		else{
 			playerExplode(p.id);
 		}

 	}


 	private function mapZap(l:Lazer,p:FlxTilemap){
		lazerExplode(l);
		l.kill();
 	}

 	private function basicZap(l:Lazer,p:FlxSprite){
		lazerExplode(l);
		l.kill();
 	}

 	private function enemyHit(l:Lazer,e:Enemy){
 		//lazerExplode(l);
 		if (e.type!=3) {
 			enemyExplode(e);
 			l.kill();
 			e.kill();
 		}
 		else{
 			if (l.type==3) {
 				 enemyExplode(e);
 				 l.kill();
 				 e.kill();
 			}
 			else{
 				e.stunned(l.velocity.x);
 				lazerExplode(l);
 				l.kill();
 			}
 		}

 	}

 	public function playerShot(p:FlxSprite,l:Lazer){
 		l.kill();
 		lazerExplode(l,3);
 		playerExplode(p.id);
 	}

 	public function shootLazer():Void{
			if (!FlxAssets.hasTriple) {
				 var tempLazer:Lazer;
				var tempDir:Int;
	 			if (ourPlayer.control&&!ourPlayer.headless){
						if (ourPlayer.facing==FlxObject.RIGHT) {
							tempDir = 1;
							tempLazer = new Lazer(ourPlayer.x+2,ourPlayer.y+6,tempDir);
						}
						else{
							tempDir =2;
							tempLazer = new Lazer(ourPlayer.x-2,ourPlayer.y+6,tempDir);
						}
						
					}
					//if we are in robohead mode
					else{
						if (roboHead.facing==FlxObject.RIGHT) {
							tempDir = 1;
							tempLazer = new Lazer(roboHead.x+2,roboHead.y+4,tempDir);
						}
						else{
							tempDir =2;
							tempLazer = new Lazer(roboHead.x-2,roboHead.y+4,tempDir);
						}				
					}//end of roboheadmode
					lazerGroup.add(tempLazer);
			}//end of has triple check
			else{
				 	 var tempLazer:Lazer;
				 	 var tempLazer2:Lazer;
				 	 var tempLazer3:Lazer;
					 var tempDir:Int;
					 if (ourPlayer.control&&!ourPlayer.headless){
						if (ourPlayer.facing==FlxObject.RIGHT) {
							tempDir = 1;
							tempLazer = new Lazer(ourPlayer.x+2,ourPlayer.y+6,tempDir,6);
							tempLazer2 = new Lazer(ourPlayer.x+2,ourPlayer.y+6,tempDir,5);
							tempLazer3 = new Lazer(ourPlayer.x+2,ourPlayer.y+6,tempDir,4);
						}
						else{
							tempDir =2;
							tempLazer = new Lazer(ourPlayer.x-2,ourPlayer.y+6,tempDir,6);
							tempLazer2 = new Lazer(ourPlayer.x-2,ourPlayer.y+6,tempDir,4);
							tempLazer3 = new Lazer(ourPlayer.x-2,ourPlayer.y+6,tempDir,5);
						}
						
					}
					//if we are in robohead mode
					else{
						if (roboHead.facing==FlxObject.RIGHT) {
							tempDir = 1;
							tempLazer = new Lazer(roboHead.x+2,roboHead.y+4,tempDir,6);
							tempLazer2 = new Lazer(roboHead.x+2,roboHead.y+4,tempDir,5);
							tempLazer3 = new Lazer(roboHead.x+2,roboHead.y+4,tempDir,4);
						}
						else{
							tempDir =2;
							tempLazer = new Lazer(roboHead.x-2,roboHead.y+4,tempDir,6);
							tempLazer2 = new Lazer(roboHead.x-2,roboHead.y+4,tempDir,4);
							tempLazer3 = new Lazer(roboHead.x-2,roboHead.y+4,tempDir,5);
						}				
					}//end of roboheadmode
					lazerGroup.add(tempLazer);
					lazerGroup.add(tempLazer2);
					lazerGroup.add(tempLazer3);

			}

 	}

 	

 	public function enemyShoot(e:Enemy4):Void{
 			var tempLazer:Lazer;
			var tempDir:Int;
					if (!ourPlayer.headless) {
						if (e.x<ourPlayer.x) {
							tempDir = 1;
							tempLazer = new Lazer(e.x+8,e.y+12,tempDir,2);
						}
						else{
							tempDir =2;
							tempLazer = new Lazer(e.x-8,e.y+12,tempDir,2);
						}
					}
					else{
						if (e.x<roboHead.x) {
							tempDir = 1;
							tempLazer = new Lazer(e.x+18,e.y+9,tempDir,2);
						}
						else{
							tempDir =2;
							tempLazer = new Lazer(e.x-18,e.y+9,tempDir,2);
						}

					}
					
				
				    eBulletGroup.add(tempLazer);

 	}

 	public function eLazerMap(m:FlxTilemap,l:Lazer){
 			lazerExplode(l,3);
 			l.kill();
 	}


 	private function lazerExplode(l:Lazer,t:Int=1){
 		var particles:Int = 16;
 		var emitter:FlxEmitter = new FlxEmitter(l.x,l.y,particles); //x and y of the emitter
 		var lifer:Float =.33;
 		wallExplosion.play();

 		//if lazer hits wall
 		if (t==1) {
	 		if (l.dir==1) {
	 			emitter.setXSpeed(-150,25);
	 		}
	 		else{
	 			FlxG.log("here");
	 			emitter.setXSpeed(-25,150);
	 		}
	 		emitter.setYSpeed(-50,50);

	 		for (i in 0...particles) {
				var particle:FlxParticle = new FlxParticle();
				if (FlxAssets.hasTriple&&!FlxAssets.hasSuperShot) {
					particle.makeGraphic(2, 1, 0xff00ff00,false);
				}else{
					particle.makeGraphic(2, 1, 0xfff10088,false);
				}		
				particle.alpha=1;
				emitter.add(particle);
			}
			lifer = .4;
		}//end of lazer wall

		//if lazer hits powerUnit
		if (t==2) {
			if (l.dir==1) {
	 			emitter.setXSpeed(-50,0);
	 		}
	 		else{
	 			FlxG.log("here");
	 			emitter.setXSpeed(0,50);
	 		}
	 		emitter.setYSpeed(-60,60);
	 		for (i in 0...particles) {
				var particle:FlxParticle = new FlxParticle();
				particle.loadGraphic(FlxAssets.sparkPartImg,false,false);
				var tempA:Float = FlxG.randomRange(7,2) * .1;
				particle.alpha=tempA;
				emitter.add(particle);
			}
			lifer = .35;
		}//end of powerUnit

		//enemy explode
		if (t==3) {
			if (l.dir==1) {
				emitter.setXSpeed(-350,125);
	 		}
	 		else{
	 			FlxG.log("here");
	 			emitter.setXSpeed(-125,350);
	 		}
	 		emitter.setYSpeed(-200,200);

	 		for (i in 0...particles) {
				var particle:FlxParticle = new FlxParticle();
				particle.makeGraphic(2, 2, 0xff00fa9e,false);
				particle.alpha=.75;
				emitter.add(particle);
			}
			lifer = .1;
		}//end of enemyShot


		add(emitter);
		emitter.start();
		emitter.lifespan = lifer;

 	}


 	public function hitPowerUP(p:FlxSprite,pu:Parachute){
 		powerUpSound.play();
 		if (pu.type==1&&!FlxAssets.hasForce) {
 			makeForceField();
 		}
 		if (pu.type==2&&!FlxAssets.hasTriple) {
 			FlxAssets.hasTriple=true;
 			if (ourPlayer.lazerCharging) {
 				eyes.swapGraphic(2);
 			}
 			
 		}
 		if (pu.type==3) {
 			makeSuperShot();
 		}
 		pu.kill();
 	}

 	public function makeSuperShot(){
 		FlxAssets.hasSuperShot = true;
		lazerMadnessTimer = 13;
	    lazerMadnnessOffset = 0;
	    if(!ourPlayer.lazerCharging){
	    	eyes = new Eyes(ourPlayer.x,ourPlayer.y);
			add(eyes);
		}

 	}


 	public function lazerMadness():Void{

 			if (lazerMadnessTimer>0) {
 					lazerMadnessTimer-=FlxG.elapsed;
 					lazerMadnnessOffset++;
 				if (lazerMadnnessOffset%2==0) {
		 			var tempLazer:Lazer;
					var tempDir:Int;


		 			if (ourPlayer.control&&!ourPlayer.headless){
							if (ourPlayer.facing==FlxObject.RIGHT) {
								tempDir = 1;
								tempLazer = new Lazer(ourPlayer.x+2,ourPlayer.y+6,tempDir,3);
							}
							else{
								tempDir =2;
								tempLazer = new Lazer(ourPlayer.x-2,ourPlayer.y+6,tempDir,3);
							}
							
						}
						//if we are in robohead mode
						else{
							if (roboHead.facing==FlxObject.RIGHT) {
								tempDir = 1;
								tempLazer = new Lazer(roboHead.x+2,roboHead.y+4,tempDir,3);
							}
							else{
								tempDir =2;
								tempLazer = new Lazer(roboHead.x-2,roboHead.y+4,tempDir,3);
							}				
						}//end of roboheadmode
						lazerGroup.add(tempLazer);
				}

		}//end of lazer madness timer
		else{
			//turn off lazer madness
			FlxAssets.hasSuperShot = false;
			eyes.kill();
		}

 	}




 	public function makeForceField(){
 		ourForceField = new FlxSprite(ourPlayer.x,ourPlayer.y);
 		ourForceField.loadGraphic(FlxAssets.forceField,true,false,27,26);
 		ourForceField.addAnimation("normal",[0,1,2,1],16);
 		ourForceField.alpha=.8;
 		ourForceField.scale.x=0;
 		ourForceField.scale.y=0;
 		Actuate.tween(ourForceField.scale,.5,{x:1,y:1});
 		ourForceField.play("normal");
 		forceGroup.add(ourForceField);
 		FlxAssets.hasForce=true;
 	}

 	public function destroyForceField(){
 		FlxAssets.hasForce=false;
 		ourForceField.kill();
 	}

 	private function enemyExplode(e:Enemy){

 		var particles:Int = 20;
 		var emitter:FlxEmitter = new FlxEmitter(e.x,e.y,particles); //x and y of the emitter
 		emitter.setXSpeed(-80,80);	
 		emitter.setYSpeed(-90,160);
 		enemyExplosion.play();

 		if (e.type==1) {
	 		for (i in 0...particles) {
				var particle:FlxParticle = new FlxParticle();
				if (i%7==0) {
					particle.makeGraphic(1, 1, 0xffffffff,false);	
				}
				else if (i%3==0) {
					particle.makeGraphic(2, 2, 0xff96254b,false);	
				}
				else{
					particle.makeGraphic(3, 2, 0xffff3366,false);
				}

				particle.angularVelocity = 5.0;
				particle.alpha = .75;
				emitter.add(particle);
			}
		}

		if (e.type==2) {
			for (i in 0...particles) {
				var particle:FlxParticle = new FlxParticle();
				if (i%7==0) {
					particle.makeGraphic(1, 1, 0xffffffff,false);	
				}
				else if (i%3==0) {
					particle.makeGraphic(2, 2, 0xffdf4a29,false);	
				}
				else{
					particle.makeGraphic(3, 2, 0xffff7f40,false);
				}

				particle.angularVelocity = 5.0;
				particle.alpha = .75;
				emitter.add(particle);
			}
		}

		if (e.type==3) {
	 		for (i in 0...particles) {
				var particle:FlxParticle = new FlxParticle();
				if (i%7==0) {
					particle.makeGraphic(1, 1, 0xffffffff,false);	
				}
				else if (i%3==0) {
					particle.makeGraphic(2, 2, 0xff8d1a68,false);	
				}
				else{
					particle.makeGraphic(3, 3, 0xfffe297c,false);
				}

				particle.angularVelocity = 5.0;
				particle.alpha = .75;
				emitter.add(particle);
			}
		}



		if (e.type==4) {
			for (i in 0...32) {
				var particle:FlxParticle = new FlxParticle();
				if (i%7==0) {
					particle.makeGraphic(1, 1, 0xffffffff,false);	
				}
				else if (i%3==0) {
					particle.makeGraphic(3, 2, 0xffba2fb1,false);	
				}
				else{
					particle.makeGraphic(2, 2, 0xff8e2699,false);
				}

				particle.angularVelocity = 5.0;
				particle.alpha = .75;
				emitter.add(particle);
			}
		}

		add(emitter);
		emitter.start();
		emitter.lifespan = .22;

 	}

 	public function createPowerUp(t:Int,x:Int,chance:Int){
 			var birthChance:Int = FlxG.randomRange2(chance+1,1);
 			FlxG.log("birthchance: "+birthChance);
 			if (t==1&&birthChance==1) {
 				var tempParachute:Parachute = new Parachute(x,-10,1);
				powerUpGroup.add(tempParachute);
 			}

 			if(t==2&&birthChance==1){
 				var tempParachute:Parachute = new Parachute(x,-10,2);
				powerUpGroup.add(tempParachute);
 			}

 			 if(t==3&&birthChance==1){
 				var tempParachute:Parachute = new Parachute(x,-10,3);
				powerUpGroup.add(tempParachute);
 			}
 			//either or birth cases
 			 if(t==4&&birthChance==1){
 			 	var whichUp:Int = FlxG.randomRange2(3,1);
 				var tempParachute:Parachute = new Parachute(x,-10,whichUp);
				powerUpGroup.add(tempParachute);
 			}

 			if(t==5&&birthChance==1){
 			 	var whichUp:Int = FlxG.randomRange2(4,1);
 				var tempParachute:Parachute = new Parachute(x,-10,whichUp);
				powerUpGroup.add(tempParachute);
 			}
 	}
 	

 	private function playerEnemyHit(p:FlxSprite,e:Enemy):Void{

 		if (FlxAssets.hasForce) {
 			if (e.type==3) {
 				e.type=1;
 			}
 			enemyExplode(e);
 			e.kill();
 		}
 		playerExplode(p.id);
 		//resetLevel();

 	}

 	private function playerExplode(who:Int):Void{
 		if (FlxAssets.hasForce&&who==1) {	
 			destroyForceField();
 		}
 		else if(!hasTaco){
 			explosionSound.play();
 			if (who==2) {
 				roboHead.kill();
 				 if (FlxAssets.hasForce) {	
 					destroyForceField();
 				}
 			}
 			else{
 				ourPlayer.kill();
 			}
	 		
	 		haxe.Timer.delay(callback(resetLevel), 333);
	 		FlxAssets.hasTriple=false;
	 		var particles:Int = 20;
	 		 if (ourPlayer.headless) {
	 		    particles = 10;

	 		}
	 		var emitter:FlxEmitter = new FlxEmitter(ourPlayer.x,ourPlayer.y,particles); //x and y of the emitter
	 		
	 		//if (ourPlayer.headless) {
	 			if(who==1){
	 				emitter.x=ourPlayer.x;
	 			    emitter.y = ourPlayer.y;
	 			}
	 			else{
	 				emitter.x=roboHead.x;
	 				emitter.y = roboHead.y;
	 			}
	 		//}

	 		var lifer:Float =.33;
	 		emitter.setXSpeed(-150,150);	
	 		emitter.setYSpeed(-150,150);

	 		for (i in 0...particles) {
					var particle:FlxParticle = new FlxParticle();
					if (i<14) {
						particle.loadGraphic(FlxAssets.roboParts,true,false,4,3);
						particle.frame=i;
					}
					else{
						particle.makeGraphic(2,2,0xff989898,false);
					}
					particle.angularVelocity = 5.0;
					particle.alpha = 1;
					emitter.add(particle);
			}
			add(emitter);
			emitter.start();
			emitter.lifespan = .28;
		}//end of else to check for forceField


 	}//end of explode player

 	private function resetLevel():Void{
 		 if (FlxAssets.gameMode==2) {
 		 	if (FlxAssets.hotLives==1) {
 		 		hotGameOver();
 		 	}
 		 	else{
 		 		FlxAssets.hotLives--;
 		 	 	FlxG.switchState(new Level2(2));
 		 	}
 		 }
 		 
 		 if (FlxAssets.gameMode==1) {
 		 	if (FlxAssets.tacoNum>1) {
 				FlxAssets.tacoNum--;
 		 	}
 		 	 FlxG.switchState(new Level2(2));
 		}
	 			
 			//defined by each level
 	}

	private function buttonHit(b:Button,r:FlxSprite):Void{
			if(b.type!=3&&b.touching == FlxObject.UP){
				b.buttonDown();
				openDoors(b.type);
			}

			if (b.type==3&&b.touching == FlxObject.DOWN) {
				b.buttonDown();
				openDoors(1);
				buttonClick.play();
			}
	}

	public function buttonUp(t:Int):Void{
		for (i in 0...doorGroup.length) {
			var d = cast(doorGroup.members[i], Door);
			if(d.type==t&&!d.closed){
				d.closeDoor();
			}
		}
	}

	private function openDoors(type:Int):Void{
		for (i in 0...doorGroup.length) {
			var d = cast(doorGroup.members[i], Door);
			if(d.type==type&&d.closed){
				d.openDoor();
			}
		}
	}//end of openDoors


	public function explodePowerU(l:Lazer,pu:PowerU){
		l.kill();
		pu.frame=5;
		zapSound.play();
		if (pu.powered) {
			lazerExplode(l,2);
			pu.powered=false;
		}
		else{
			lazerExplode(l);
		}
		
		pu.alive = false;
		if (powerUGroup.countLiving()==0) {
			for (i in 0...enviroGroup.length) {
				var d = cast(enviroGroup.members[i], Sparks);
				d.openDoor();
			}
		}

	}//end of explode powerU

	public function spitterShoot(x:Float,y:Float){
		var spit:Spit = new Spit(x+4,y+2);
		spit.velocity.y=-550;
		spitGroup.add(spit);
	}

	public function spitExplode(sp:Spit,o:FlxSprite){
		spitSplosion(sp.x,sp.y);
		sp.kill();
		
	}

	public function spitSplosion(x:Float,y:Float){
		var particles:Int = 16;
 		var emitter:FlxEmitter = new FlxEmitter(x,y,particles); //x and y of the emitter
 		var lifer:Float =.33;
 		emitter.setXSpeed(-140,140);	
 		emitter.setYSpeed(100,200);

 		for (i in 0...particles) {
				var particle:FlxParticle = new FlxParticle();
				particle.loadGraphic(FlxAssets.spitBubble,false,false);
				particle.angularVelocity = 5.0;
				particle.alpha = .75;
				emitter.add(particle);
		}
		add(emitter);
		emitter.start();
		emitter.lifespan = .25;
	}

	public function mapSpit(sp:Spit,m:FlxTilemap){
		spitSplosion(sp.x,sp.y);
		sp.kill();
	}

	public function spitHit(sp:Spit,ob:FlxSprite){
		spitSplosion(sp.x,sp.y);
		sp.kill();
		playerExplode(ob.id);
	}

	public function trampHit(p:Player,t:Tramp){
		if (t.type==1&&p.touching==FlxObject.DOWN) {
			t.play("spring");
			p.trampJump(1);
			p.onGround=false;
			p.tramp=true;
			p.velocity.y=-1200;
			t.playBoing();
		}



	}

	public function sideTrampHit(t:Int,tr:Tramp){
		tr.playBoing();
		 if (t==1) {
			tr.play("spring");
			ourPlayer.facing = FlxObject.LEFT;
			ourPlayer.trampJump(2);
			ourPlayer.onGround=false;
			ourPlayer.tramp=true;
			ourPlayer.velocity.x=-900;
			
		}
		else{
			tr.play("spring");
			ourPlayer.facing = FlxObject.RIGHT;
			ourPlayer.trampJump(2);
			ourPlayer.onGround=false;
			ourPlayer.tramp=true;
			ourPlayer.velocity.x=900;

		}
		


	}

	public function mapHitter(){
		ourPlayer.trampType=0;
	}

	
	
	
	//This just quits - state.destroy() is automatically called upon state changing
	private function onQuit():Void 
	{
		FlxG.switchState(new MenuState());
	}
}