package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxBasic;
import org.flixel.FlxTilemap;
import org.flixel.FlxObject;
import nme.Assets;

import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Elastic;



class Level8 extends BaseLevel
{
	private var door1:Door;
	private var button1:Button;
	private var pU1:FlxSprite;
	
	
	
	override public function create():Void
	{
	

		backGround = new FlxSprite(0,0);
		backGround.alpha = .5;
		backGround.loadGraphic(FlxAssets.bgImage2,false,false,800,600);
		add(backGround);


		map = new FlxTilemap();
		map.loadMap(Assets.getText("assets/mapCSV_Group1_Level8.csv"),FlxAssets.tileImg2,20,20,FlxTilemap.OFF);
		add(map);
		super.create();

		//reput the taco
		taco.y=560;
		taco.x=388;

		//place the player
		ourPlayer.x=396;
		ourPlayer.y=40;
		ourPlayer.facing = FlxObject.LEFT;

		var flyingEnemy:Enemy2 = new Enemy2(FlxG.randomRange(300,280),300,this);
		enemyGroup.add(flyingEnemy);

		var flyingEnemy2:Enemy2 = new Enemy2(270,250,this);
		enemyGroup.add(flyingEnemy2);

		var flyingEnemy3:Enemy2 = new Enemy2(FlxG.randomRange(240,220),300,this);
		enemyGroup.add(flyingEnemy3);



		var flyingEnemy4:Enemy2 = new Enemy2(FlxG.randomRange(320,300),FlxG.randomRange(380,320),this,2);
		enemyGroup.add(flyingEnemy4);

		var flyingEnemy5:Enemy2 = new Enemy2(FlxG.randomRange(290,250),FlxG.randomRange(360,300),this,2);
		enemyGroup.add(flyingEnemy5);

		var flyingEnemy6:Enemy2 = new Enemy2(FlxG.randomRange(230,180),FlxG.randomRange(380,320),this,2);
		enemyGroup.add(flyingEnemy6);


		
		//left small
		 for (i in 0...14) {
			var testSparks4:Sparks = new Sparks(162+(i*15),488,2,1,1);
			enviroGroup.add(testSparks4);
		}

		for (i in 0...14) {
			var testSparks5:Sparks = new Sparks(424+(i*15),488,2,1,1);
			enviroGroup.add(testSparks5);
		}

		stars.x = taco.x;
		stars.y = taco.y-6;





		//Power Up Section
		add(powerUpGroup);
		//type of powerup, x location, chance of birth, time frame to birth
		powerUpTimer = haxe.Timer.delay(callback(createPowerUp,2,FlxG.randomRange2(600,200),2), FlxG.randomRange2(5000,1000));

		
	}


	override public function nextLevel():Void{
		FlxG.switchState(new Level9());
	}

	override private function resetLevel():Void{
		powerUpTimer.stop();
		 if (FlxAssets.gameMode==2) {
 		 	if (FlxAssets.hotLives==1) {
 		 		hotGameOver();
 		 	}
 		 	else{
 		 		FlxAssets.hotLives--;
 		 	 	FlxG.switchState(new Level8(2));
 		 	}
 		 }
 		 
 		 if (FlxAssets.gameMode==1) {
 		 	if (FlxAssets.tacoNum>1) {
 				FlxAssets.tacoNum--;
 		 	}
 		 	 FlxG.switchState(new Level8(2));
 		}
 	}
	


	

	
	override public function update():Void
	{
		super.update();
		FlxG.collide(doorGroup,robotGroup);
		FlxG.collide(buttonGroup,robotGroup,buttonHit);
		FlxG.collide(enemyGroup,map);
		FlxG.collide(enemyGroup,doorGroup);
		FlxG.overlap(ourPlayer,enviroGroup,enviroHit);
		FlxG.overlap(robotGroup,enviroGroup,enviroHit);

		FlxG.collide(lazerGroup,powerUGroup,explodePowerU);
		FlxG.collide(lazerGroup,enemyGroup,enemyHit);
		FlxG.collide(lazerGroup,map,mapZap);
		updateParts();

	}//end of update

	

	

}