package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxObject;
import org.flixel.FlxSound;
import nme.Assets;


class Player extends FlxSprite
{
	//This is for our messages
	private var topText:FlxText;
	public var jump:Float;
	public var onGround:Bool;
	public var ourSpeed:Float;
	public var stillTime:Float;
	public var headless:Bool;
	public var control:Bool;
	public var lazerCharging:Bool;
	public var tramp:Bool;
	public var trampCount:Int;
	public var trampType:Int;
	private var trampCDown:Float;
	public var hasForce:Bool;
	private var walkSound:FlxSound;
	public var jumpSound:FlxSound;
	
	
	public function new(X:Int, Y:Int)
	{
		
		//sound stuff
		walkSound = FlxG.loadSound(Assets.getSound ("assets/sounds/walkClicks.mp3"),.175);
		jumpSound = FlxG.loadSound(Assets.getSound ("assets/sounds/Jump.mp3"),.45);

		super(X,Y);
		loadGraphic(FlxAssets.robotImg,true,true,20,24);
		jump=0;
		onGround = false;
		ourSpeed = 155;
		width=8;
		this.offset.x=6;
		offset.y=-2;
		stillTime = 0;
		headless = false;
		control = true;
		hasForce=false;
		//elasticity = .4;

		lazerCharging = false;

		acceleration.y=1100;
		//maxVelocity.y = 700;
		maxVelocity.y=700;
		this.drag.x=ourSpeed*3;
		addAnimation("walk",[2,3,4,3],12);
		addAnimation("jump",[4],12);
		addAnimation("stopped",[1,1,1,1,1,1,1,1,1,1,0,0,1],12);
		addAnimation("noHead",[0,6,7,8,7,6,0,6,7,8,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,7,8,7,6,0,6,7,8,7,6,0,6,7,8,7,6,0,6,7,8,7,6],12);
		play("stopped");
		
		tramp = false;
		trampCount = 0;
		id=1;

	}
	
	/*
	override public function create():Void
	{
	
		

	}
	*/
	

	override public function update():Void
	{

		if(control){
			if (touching == FlxObject.DOWN){
				jump = 0;
				onGround = true;
				maxVelocity.y=700;
			}
			if((jump>=0) && FlxG.keys.UP){
				if(onGround){
					jumpSound.play();
				}
				onGround=false;
				stillTime=0;
				jump += FlxG.elapsed;
				play("jump");
				if(jump> 0.25){
					jump = -1;
				}
			}
			else{
				jump = -1;
			}

			if(jump>0){
				if(jump < 0.065)
					velocity.y = -100;
				else
					velocity.y = -maxVelocity.y*.55;
					//velocity.y = -maxVelocity.y*.5;

			}
			if(y<-24){
				velocity.y=0;
			}


			if(FlxG.keys.LEFT&&x>0&&trampType!=2){
				if(onGround){
					walkSound.play();
				}
				stillTime=0;
				this.facing= FlxObject.LEFT;
				velocity.x=-ourSpeed;
				if(onGround){
					play("walk");
				}
			}
			else if(FlxG.keys.RIGHT&&x+8<FlxG.width&&trampType!=2){
				if(onGround){
					walkSound.play();
				}
				stillTime=0;
				velocity.x=ourSpeed;
				facing = FlxObject.RIGHT;
				if(onGround){
					play("walk");
				}
			}
			else{
				if (!tramp) {
					velocity.x*=.1;
			    }
				if(onGround)
				{
					stillTime+=FlxG.elapsed;
					if(stillTime>=3){
						play("stopped");
					}
					else{
						frame=2;
					}
				}
				else
					play("jump");
			}

		}//end of control check
		else{
			play("noHead");
		}


		if (tramp) {
			maxVelocity.y=900;
			trampCDown-=FlxG.elapsed;
			if (trampType==2&&trampCDown>=0) {
				acceleration.y=800;
				velocity.y=0;
				
			}
			else{
				//trampType=0;
				//acceleration.y=1100;
				//velocity.y=10;
			}
			play("jump");
			if (touching == FlxObject.DOWN&&trampCount>1) {
				tramp=false;
				acceleration.y=1100;
				maxVelocity.y=850;
				trampCount=0;
				trampType=0;
			}
			trampCount++;
		}






		
	}//end of update


	public function loseHead():Void{
		y+=12;
		loadGraphic(FlxAssets.robotHeadlessImg,true,true,20,12);
		velocity.x=0;
		//this.acceleration.y=2000;
		control = false;
		//facing = FlxObject.RIGHT;
		headless = true;

		width=8;
		//height=12;
		//offset.y=12;
		this.offset.x=6;
		//offset.y=;

	}//end of lose head

	public function trampJump(t:Int):Void{
			trampType = t;
			trampCDown = .25;
	}

	public function getHead():Void{
		y-=12;
		loadGraphic(FlxAssets.robotImg,true,true,20,24);
		control = true;
		//facing = FlxObject.RIGHT;
		headless = false;
		width=8;
		this.offset.x=6;
		

	}
	
	
	

}